-------------------------------------------------------
-- DB Version        _      __     __     __
--                  / |    /_ \   /  \   /  \
--                   ||    _|.|   |()|   |()|
--                  |__| o \__/ o \__/ o \__/
-------------------------------------------------------
CREATE TABLE [DbProperties] ([Key] ntext NOT NULL,	[Value] ntext);
INSERT INTO [DbProperties]([Key], [Value]) VALUES ('Version', '1.3.0.0');

--  Create Tables 

CREATE TABLE [HistoricalData] ( 
	[ID] int identity(1,1)  NOT NULL,
	[Timestamp] datetime NOT NULL,
	[Type] smallint NOT NULL,
	[IDLastAll] int,
	[IDRef] int NOT NULL,
	[BinaryLength] smallint NOT NULL,
	[Data00] varbinary(500),
	[Data01] varbinary(500),
	[Data02] varbinary(500),
	[Data03] varbinary(500),
	[Data04] varbinary(500),
	[Data05] varbinary(500),
	[Data06] varbinary(500),
	[Data07] varbinary(500),
	[Data08] varbinary(500),
	[Data09] varbinary(500)
)
;


--  Create Primary Key Constraints 
ALTER TABLE [HistoricalData] ADD CONSTRAINT [PK_ID] 
	PRIMARY KEY ([ID])
;

--  Create Indexes 
CREATE INDEX [IDX_Type_Timestamp]
ON [HistoricalData] ([Type] ASC, [Timestamp] ASC)
;

CREATE INDEX [IDX_Timestamp]
ON [HistoricalData] ([Timestamp] ASC)
;
