// Functions for canceling the data load.




/*//////////////////////////// DOMREADY ////////////////////////////
_______________________________________________________________________________________________________ */


// NOTE: we don't use the dom-ready event to initialize the widget,
// but the "amChartInited" function fired by the movieclip when ready 
// which occurs after the dom-ready event, that's the reason.

var amchartFlashMovie_zoomFrom;
var amchartFlashMovie_zoomTo;


/*//////////////////////////// FUNCTIONS ////////////////////////////
_______________________________________________________________________________________________________ */


function cancelInvocation() {
    new Request({ url: '/HistoricalChartDataInvocation.rix' }).send("modality=ajax&exec=cancel");
}

function delayed() {
    document.window.myChart.delayedPrint();
}

///////////////////////////////////////
// Functions called by the chart //////
///////////////////////////////////////

// CHART INITED ///////////////////////
// amChartInited(chart_id)
// This function is called when the chart is fully loaded and initialized.
function amChartInited(chart_id) {

    $('loadingMessage').setStyle('display', 'none');

    // get the flash object into "amchartFlashMovie" variable
    amchartFlashMovie = document.getElementById(chart_id);

    // initialize the chart widget
    if (!$chk(this.myChart)) {
        this.myChart = new amchartWidget(amchartFlashMovie);
    }
}

// RETURN PARAM ///////////////////////
// amReturnParam(chart_id, param)
// This function is called when you request a setting from a chart  
// by calling the amchartFlashMovie.getParam(param) function.
function amReturnParam(chart_id, param) {
    document.getElementById("get_value").value = unescape(param);
    return param;
}

// RETURN SETTINGS ////////////////////
// amReturnSettings(chart_id, settings)
// This function is called when you request settings from a chart 
// by calling amchartFlashMovie.getSettings() function.  
function amReturnSettings(chart_id, settings) {
    // document.getElementById("settings").value = unescape(settings);
    // console.log(unescape(settings))

    // 	var xmlcontainer = new Element('div');
    // 	xmlcontainer.appendText(settings);
    // 	document.appendChild(settings);

    // 	xmlcontainer.appendChild(document.createTextNode(text));
    // 	xmlcontainer.inject(document.body);

    // 	var charts = xmlcontainer.getElementsByTagName('charts')[0].getElementsByTagName('chart').each(function(el) { console.log(el.getProperty('cid')); });
    // 	
    // 	console.log(xmlcontainer);
    // 	console.log(xmlcontainer.getElementsByTagName('charts')[0]);

}

// RETURN IMAGE DATA //////////////////
// amReturnImageData(chart_id, data)
// This function is called when the export to image process is finished and might be used
// as alternative way to get image data (instead of posting it to some file)
/*function amReturnImageData(chart_id, data){
// your own functions here
}*/

// ERROR //////////////////////////////
// amError(chart_id, message)
// This function is called when an error occurs, such as no data, or file not found.
function amError(chart_id, message) {
    alert(message);
}

// GET ZOOM ///////////////////////////
// amGetZoom(chart_id, from, to)
// this function is called every time then the selected period is changed
function amGetZoom(chart_id, from, to) {
    // update zoom value holders
    amchartFlashMovie_zoomFrom = from;
    amchartFlashMovie_zoomTo = to;
}



///////////////////////////////////////
// Functions that control the chart ///
///////////////////////////////////////

// SET PARAM /////////////////////////////////////////////////////////////////////////////
// flashMovie.setParam(param, value)
// This function lets you change a single setting. The parameter names are formed using 
// the section name and the parameter name, separated with a period. For example: 
// background.alpha or labels.label[1].text 
function setParam() {
    // gets param name from a field with id "set_param"
    var param = document.getElementById("set_param").value;
    // gets param value from a field with id "set_value"
    var value = document.getElementById("set_value").value;
    // sets param
    amchartFlashMovie.setParam(param, value);
}

// GET PARAM /////////////////////////////////////////////////////////////////////////////
// flashMovie.getParam(param)
// This function will ask Flash to return the value of a setting. The parameter name is
// formed in the same way as the setParam function (described above). When you call this
// function to return the setting value, Flash will return the value by calling the 
// amReturnParam(chart_id, param_value) function
function getParam() {
    // get the param name from a field with id "get_param"
    var param = document.getElementById("get_param").value;
    amchartFlashMovie.getParam(param);
}

function amchartParseTextToDate(textdate) {
    // parse text date
    regexdate = textdate.match(/^(\d{2})-(\d{2})-(\d{4}) (\d{2}):(\d{2}):(\d{2})$/);
    // convert matched text date to javascript datetime
    var jsdate = new Date(regexdate[3], regexdate[2] - 1, regexdate[1], regexdate[4], regexdate[5], 0);
    return jsdate;
}

function amchartParseDateToText(jsdate) {
    // build the text string
    var txtdate = '';
    txtdate += zeroPad(jsdate.getDate(), 2)
    txtdate += '-';
    txtdate += zeroPad(jsdate.getMonth() + 1, 2);
    txtdate += '-';
    txtdate += (jsdate.getFullYear());
    txtdate += ' ';
    txtdate += zeroPad(jsdate.getHours(), 2);
    txtdate += ':';
    txtdate += zeroPad(jsdate.getMinutes(), 2);
    return txtdate;
}


/*//////////////////////////// CLASSES ////////////////////////////
_______________________________________________________________________________________________________ */


var amchartWidget = new Class({

    initialize: function(mov) {

        // store reference to the movie
        this.swfChartMovie = mov;

        // store behaviour objects
        this.boxChartWrapper = $('boxChartWrapper');
        this.boxChartPlaceholder = $('boxChartPlaceholder');
        this.boxChartCommands = $('boxChartCommands');
        this.boxChartSetup = document.getElement('.wkaChartSettings');

        /* ---------------
        CHART SETTINGS
        --------------- */

        if (this.boxChartSetup) {

            //  assign behaviour to the toolbar toggler button
            this.watChartSetup = document.getElement('.wkaToolbarArea a.watChartsetup');

            if (this.watChartSetup) {
                // this.watChartSetup.onclick = function(){ this.fxSlider.toggle(); return false; } 
                // this.watChartSetup.fxSlider = new Fx.Slide(this.boxChartSetup, {duration: 500, wait: false});
                // this.watChartSetup.fxSlider.hide();

                this.watChartSetup.addEvent('click', this.toggle.bind(this));
                this.watChartSetup.onclick = function() { return false; }

                // add behaviour to the "apply" button
                this.btnApplySetup = document.getElement('#wcsApplySettings', this.boxChartSetup);
                this.btnApplySetup.addEvent('click', this.apply_settings.bindAsEventListener(this));
            }
        }

        /* ---------------
        CHART COMMANDS
        --------------- */

        // chart custom commands handler
        if (document.getElement('#boxChartCommands #amcSnap')) { document.getElement('#boxChartCommands #amcSnap').addEvent('click', this.zoomSnapToDate.bindWithEvent(this)); }
        if (document.getElement('#boxChartCommands #amcShiftLeft')) { document.getElement('#boxChartCommands #amcShiftLeft').addEvent('click', this.zoomShiftInterval.bindWithEvent(this, 'left')); }
        if (document.getElement('#boxChartCommands #amcShiftRight')) { document.getElement('#boxChartCommands #amcShiftRight').addEvent('click', this.zoomShiftInterval.bindWithEvent(this, 'right')); }

        // chart show/hide modifiers
        if ($('chkTimelineVisible')) { $('chkTimelineVisible').addEvent('click', this.stageShowHideTimeline.bindWithEvent(this)); }
        if ($('chkPeriodsVisible')) { $('chkPeriodsVisible').addEvent('click', this.stageShowHidePeriods.bindWithEvent(this)); }
        if ($('chkEventsVisible')) { $('chkEventsVisible').addEvent('click', this.stageShowHideEvents.bindWithEvent(this)); }

        // chart toolbar buttons handlers
        if (document.getElement('.wkaToolbarArea a.watChartExportImage')) { document.getElement('.wkaToolbarArea a.watChartExportImage').addEvent('click', this.functionExportImage.bindWithEvent(this)); }
        if (document.getElement('.wkaToolbarArea a.watChartPrintImage')) { document.getElement('.wkaToolbarArea a.watChartPrintImage').addEvent('click', this.functionPrint.bindWithEvent(this)); }

        // debugging
        //        $('debugGetSettings').addEvent('click', this.functionGetSettings.bind(this));
        //        $('debugRebuildChart').addEvent('click', this.functionRebuild.bind(this));

    },

    toggle: function() {
        var bol = (this.boxChartSetup.getStyle('display') == 'block');
        this.boxChartSetup.setStyle('display', bol ? 'none' : 'block');
    },

    apply_settings: function() {

        // init the xml text container
        var xmlset = '';

        // set threshold min/max values (as events)
        var ythrsmin = $('inpYScaleThresholdMin').getValue().toFloat();
        var ythrsmax = $('inpYScaleThresholdMax').getValue().toFloat();
        xmlset += '<data_sets><data_set did="ds1"><events>';
        if (ythrsmin != 'NaN') { xmlset += '<event><graph_id>none</graph_id><y_axis>left</y_axis><bullet>horizontal_line</bullet><border_color>333333</border_color><text_color>999999</text_color><value>' + ythrsmin + '</value></event>'; }
        if (ythrsmax != 'NaN') { xmlset += '<event><graph_id>none</graph_id><y_axis>left</y_axis><bullet>horizontal_line</bullet><border_color>333333</border_color><text_color>999999</text_color><value>' + ythrsmax + '</value></event>'; }
        xmlset += '</events></data_set></data_sets>';

        // set y-axes min/max values
        var yleftmin = $('inpYScaleLeftMin').getValue().toFloat();
        var yleftmax = $('inpYScaleLeftMax').getValue().toFloat();
        var yrightmin = $('inpYScaleRightMin').getValue().toFloat();
        var yrightmax = $('inpYScaleRightMax').getValue().toFloat();
        xmlset += '<charts><chart cid="analogs">';
        xmlset += '<values>';
        xmlset += '<y_left>';
        if (yleftmin != 'NaN') { xmlset += '<min>' + yleftmin + '</min>'; }
        if (yleftmax != 'NaN') { xmlset += '<max>' + yleftmax + '</max>'; }
        xmlset += '</y_left>';
        xmlset += '<y_right>';
        if (yrightmin != 'NaN') { xmlset += '<min>' + yrightmin + '</min>'; }
        if (yrightmax != 'NaN') { xmlset += '<max>' + yrightmax + '</max>'; }
        xmlset += '</y_right>';
        xmlset += '</values>';
        xmlset += '</chart></charts>'

        // apply settings (with rebuild)
        // console.log(xmlset);
        this.swfChartMovie.setSettings('<settings>' + xmlset + '</settings>', true, false);

        // close the settings box
        // this.watChartSetup.fxSlider.slideOut();  // better to leave open, it's more user-friendly

        // rebuild the movie, at last (if not rebuilt above)
        // this.swfChartMovie.rebuild();

    },

    // GET SETTINGS /////////////////////////////
    // flashMovie.getSettings()
    // This function will ask Flash to return the whole settings XML. When you call this 
    // function to return the settings, Flash will call the 
    // amReturnSettings(chart_id, settings) function. 
    functionGetSettings: function() {
        this.swfChartMovie.getSettings();
    },

    // REBUILD CHART ////////////////////////////
    // This function might be used to rebuild the chart after portions of settings were
    // set using setSettings(settings, rebuild) function, with the rebuild set to false
    functionRebuild: function() {
        this.swfChartMovie.rebuild();
    },

    // EXPORT AS IMAGE ////////////////////
    // This function will start the process of exporting the chart as an image. The file_name
    // is a name of a file to which image data will be posted (files provided in the download 
    // package are export.php and export.aspx). The file_name is optional and can be set in 
    // the <export_as_image><file> setting.
    functionExportImage: function(event) {
        event.stop();
        this.swfChartMovie.exportImage();
    },

    // PRINT //////////////////////////////
    // amchartFlashMovie.print()
    // This function will print the chart. Use this print function if you don't have any
    // values rotated by 90 degrees, also if you don't have a custom bitmap background.
    functionPrint: function(event) {
        event.stop();
        this.swfChartMovie.width = "900px";
        setTimeout("delayed()", 2000);
    },

    delayedPrint: function() {
        this.swfChartMovie.print();
        this.swfChartMovie.width = "100%";
    },

    // PRINT AS BITMAP ////////////////////
    // amchartFlashMovie.printAsBitmap()
    // Use it if you have values rotated by 90 degrees and/or a custom bitmap background.
    functionPrintAsBitmap: function(event) {
        event.stop();
        this.swfChartMovie.printAsBitmap();
    },

    // change the currently selected date range
    zoomSetInterval: function(from, to) {
        this.swfChartMovie.setZoom(from, to);
    },

    // shift the date interval to left/right by the same amount
    zoomShiftInterval: function(event, mode) {
        event.stop();
        var jsfrom = amchartParseTextToDate(amchartFlashMovie_zoomFrom);
        var jsto = amchartParseTextToDate(amchartFlashMovie_zoomTo);
        var jsdiff = (jsto - jsfrom);
        switch (mode) {
            case 'left':
                // shift starting point ("from")
                jsfrom.setTime(jsfrom.getTime() - jsdiff);
                this.zoomSetInterval(amchartParseDateToText(jsfrom), amchartFlashMovie_zoomFrom);
                break;
            case 'right':
                // shift ending point ("to")
                jsto.setTime(jsto.getTime() + jsdiff);
                this.zoomSetInterval(amchartFlashMovie_zoomTo, amchartParseDateToText(jsto));
                break;
        }

    },

    // snap the date range to a single day
    zoomSnapToDate: function(event) {
        event.stop();
        this.zoomSetInterval(amchartFlashMovie_zoomFrom.substr(0, 10) + ' 00:00', amchartFlashMovie_zoomFrom.substr(0, 10) + ' 23:59');
    },

    // show all the data
    zoomShowAll: function() {
        this.swfChartMovie.showAll();
    },

    // show/hide timeline
    stageShowHideTimeline: function(event) {
        var event = new Event(event);
        // apply settings (with rebuild)
        this.swfChartMovie.setSettings('<settings><scroller><enabled>' + (event.target.checked ? 'true' : 'false') + '</enabled></scroller></settings>', true, false);
    },

    // show/hide period selector
    stageShowHidePeriods: function(event) {
        var event = new Event(event);
        // apply settings (with rebuild)
        this.swfChartMovie.setSettings('<settings><period_selector><enabled>' + (event.target.checked ? 'true' : 'false') + '</enabled></period_selector></settings>', true, false);
    },

    // show/hide event bullets
    stageShowHideEvents: function(event) {
        var event = new Event(event);
        if (event.target.checked) {
            this.swfChartMovie.showEvents();
        } else {
            this.swfChartMovie.hideEvents();
        }
    },

    // #####  DONT'T REMOVE  #####
    safari2hatesmissingcommas: function() { }

})